From 57913343fc88edd0d02008d2a45b96a1b98e3542 Mon Sep 17 00:00:00 2001
From: Nicolas ROCHE <nroche@entrouvert.com>
Date: Thu, 14 Mar 2019 15:45:05 +0100
Subject: [PATCH] correct after reading

---
 architecture-3.md |  2 +-
 exploitation-2.md |  4 ----
 exploitation-3.md |  3 +--
 installation-2.md |  2 +-
 installation-3.md |  2 +-
 installation-4.md |  9 +++------
 installation-5.md | 18 +++++++-----------
 installation-6.md |  8 ++------
 installation-7.md |  9 ++-------
 9 files changed, 18 insertions(+), 39 deletions(-)

diff --git a/architecture-3.md b/architecture-3.md
index 132678b..8842a7b 100644
--- a/architecture-3.md
+++ b/architecture-3.md
@@ -9,7 +9,7 @@ Fournisseurs d’API :
 
 -   w.c.s. est la brique qui propose le plus de webservices autour des
     demandes d’un usager (<https://doc-publik.entrouvert.com/dev/wcs/api-webservices/>) ;
--   Passerelle met en place des connecteurs donc la plupart ont pour
+-   Passerelle met en place des connecteurs dont la plupart ont pour
     objectif de remonter les informations d’un système tiers concernant
     un usager ;
 -   Passerelle est aussi utilisé pour remonter des informations de type
diff --git a/exploitation-2.md b/exploitation-2.md
index 46dccb9..7abc41c 100644
--- a/exploitation-2.md
+++ b/exploitation-2.md
@@ -46,7 +46,3 @@ sur les deux machines.
 Attention : si un service de Publik est démarré ou redémarré alors que
 PostgreSQL n'est pas disponible, ce démarrage ne fonctionnera pas. Il
 faudra redemander le démarrage explicitement.
-
-Note: la migration de tous les composants de Publik vers systemd est en
-cours et sera terminé avant fin 2017.
-
diff --git a/exploitation-3.md b/exploitation-3.md
index 18deb5f..5bd97df 100644
--- a/exploitation-3.md
+++ b/exploitation-3.md
@@ -7,8 +7,7 @@ L’historique des événements applicatifs est accessible via l'outil
 
 Pour suivre l'ensemble des composants :
 
-    # journalctl -f -u combo -u authentic2-multitenant -u wcs -u fargo -u
-hobo -u supervisor
+    # journalctl -f -u combo -u authentic2-multitenant -u wcs -u fargo -u hobo -u supervisor
 
 Les logs HTTP sont ceux de nginx, fichiers textes rangés par service
 dans */var/log/nginx :*
diff --git a/installation-2.md b/installation-2.md
index 006761d..b8bca70 100644
--- a/installation-2.md
+++ b/installation-2.md
@@ -89,7 +89,7 @@ Toutes ces entrées DNS doivent pointer vers le proxy de répartition de charge
 Par ailleurs, les serveurs applicatifs doivent impérativement avoir un
 fichier */etc/hosts* consistant.
 
-D'avantage de détails sur la sous-domaines à configurer peuvent être consultés sur https://dev.entrouvert.org/projects/publik/wiki/URL/ .
+D'avantage de détails sur les sous-domaines à configurer peuvent être consultés sur https://dev.entrouvert.org/projects/publik/wiki/URL/ .
 
 
 ## Horloges synchronisées
diff --git a/installation-3.md b/installation-3.md
index dec3636..22df723 100644
--- a/installation-3.md
+++ b/installation-3.md
@@ -29,7 +29,7 @@ Ajoutons les clés correspondantes :
     wget -O- https://www.rabbitmq.com/rabbitmq-release-signing-key.asc | apt-key add -
     apt update
 
-Pricisons les paquets qu'on veut tirer de jessie-backports en éditant
+Précisons les paquets qu'on veut tirer de jessie-backports en éditant
 */etc/apt/preferences.d/backports :*
 
     Package: python-django
diff --git a/installation-4.md b/installation-4.md
index 035dd8b..837418c 100644
--- a/installation-4.md
+++ b/installation-4.md
@@ -77,13 +77,10 @@ Voici un script pour faire cela sur web1 et web2 :
 Résultat dans /etc/passwd:
 
     hobo:x:2101:2101:hobo daemon,,,:/var/lib/hobo:/bin/false
-    authentic-multitenant:x:2102:2102:authentic2-multitenant
-    daemon,,,:/var/lib/authentic2-multitenant:/bin/false
+    authentic-multitenant:x:2102:2102:authentic2-multitenant daemon,,,:/var/lib/authentic2-multitenant:/bin/false
     wcs:x:2103:2103:wcs daemon,,,:/var/lib/wcs:/bin/false
-    wcs-au-quotidien:x:2104:2104:wcs-au-quotidien
-    daemon,,,:/var/lib/wcs-au-quotidien:/bin/false
-    passerelle:x:2105:2105:passerelle
-    daemon,,,:/var/lib/passerelle:/bin/false
+    wcs-au-quotidien:x:2104:2104:wcs-au-quotidien daemon,,,:/var/lib/wcs-au-quotidien:/bin/false
+    passerelle:x:2105:2105:passerelle daemon,,,:/var/lib/passerelle:/bin/false
     combo:x:2106:2106:combo daemon,,,:/var/lib/combo:/bin/false
     fargo:x:2107:2107:fargo daemon,,,:/var/lib/fargo:/bin/false
     welco:x:2108:2108:welco daemon,,,:/var/lib/welco:/bin/false
diff --git a/installation-5.md b/installation-5.md
index 3046deb..c91689b 100644
--- a/installation-5.md
+++ b/installation-5.md
@@ -65,9 +65,7 @@ On commence par renseigner les paramètres de connexion à la base de
 donnée :
 
 L'accès à la base de données de Combo se décrit dans
-*/etc/combo/settings.d/*.py* :
-
-    # contenu de /etc/combo/settings.d/settings.py
+*/etc/combo/settings.py* :
 
     DATABASES['default']['NAME'] = 'combo'
     DATABASES['default']['USER'] = 'combo'
@@ -75,13 +73,13 @@ L'accès à la base de données de Combo se décrit dans
     DATABASES['default']['HOST'] = 'sql-prod'
     DATABASES['default']['PORT'] = '5432'
 
-Toujours dans */etc/combo/settings.d/macollectivite.py*,
+Dans */etc/combo/settings.d/macollectivite.py*,
 nous configurons l'envoi des traces d'erreur par l'ajout de ces lignes
 en fin de fichier :
 
     ADMINS = (('Admin EO', 'admin+prod.macollectivite.combo@entrouvert.com'),)
     EMAIL_SUBJECT_PREFIX = '[prod macollectivite combo] '
-    SERVER_EMAIL = ['admin+prod.](mailto:'admin+prod.maville.combo@entrouvert.com)macollectivite[.combo@entrouvert.com](mailto:'admin+prod.maville.combo@entrouvert.com)'
+    SERVER_EMAIL = 'admin+prod.macollectivite.passerelle@entrouvert.com'
 
 On installe ensuite le logiciel *combo* :
 
@@ -111,9 +109,7 @@ Vérification avec *systemctl status combo* :
 
 La procédure est la même que pour Combo
 
-L'accès à la base de données de Passerelle se décrit dans */etc/passerelle/settings.d/*.py* :
-
-    # extrait de /etc/passerelle/settings.d/macollectivite.py
+L'accès à la base de données de Passerelle se décrit dans */etc/passerelle/settings.py* :
 
     DATABASES['default']['NAME'] = 'passerelle'
     DATABASES['default']['USER'] = 'passerelle'
@@ -121,7 +117,7 @@ L'accès à la base de données de Passerelle se décrit dans */etc/passerelle/s
     DATABASES['default']['HOST'] = 'sql-prod'
     DATABASES['default']['PORT'] = '5432'
 
-Toujours dans */etc/passerelle/settings.d/macollectivite.py*,
+Dans */etc/passerelle/settings.d/macollectivite.py*,
 configuration pour l'envoi des traces d'erreur par l'ajout de ces lignes
 en fin de fichier :
 
@@ -532,10 +528,10 @@ n'ont pas encore d'instance liés aux noms prévus.
 C'est tout de même déjà le temps de vérifier :
 
 -   que les certificats HTTPS sont ok,
--   que haproxy envoie bien sur web1,
+-   que haproxy envoie bien sur web1 (si vous l'avez déjà installé),
 -   que les requêtes arrivent sur les bons virtualhost, par exemple pour
     fargo on vérifiera que l'accès à
-    [https://portedoc-moncompte.](https://portedoc-moncompte.macollectivite.fr/)macollectivite[.fr](https://portedoc-moncompte.macollectivite.fr/)
+    [https://portedoc-moncompte.macollectivite.fr](https://portedoc-moncompte.macollectivite.fr/)
     provoque une 404 dans */var/log/nginx/fargo-access.log* et aucun
     message dans */var/log/nginx/fargo-error.log* ; opération à répéter
     avec tous les autres sites installés.
diff --git a/installation-6.md b/installation-6.md
index 21e9708..e4d8788 100644
--- a/installation-6.md
+++ b/installation-6.md
@@ -133,7 +133,7 @@ Entr'ouvert.
 Création d'un fichier
 */var/lib/authentic2-multitenant/tenants/connexion-moncompte.macollectivite.fr/settings.json.*
 
-(Conseil : prendre modèle sur le fichier identique en pré-prod et
+(Conseil : si possible, prendre modèle sur le fichier identique en pré-prod et
 adapter les paramètres LDAP).
 
     {
@@ -191,8 +191,4 @@ avec :
 
 Cette commande ne doit rien afficher (ce qui signifie que tout s'est
 bien déroulé), les comptes doivent être visibles dans
-[https://connexion-moncompte.](https://connexion-moncompte.macollectivite.fr/manage/users/)macollectivite[.fr/manage/users/](https://connexion-moncompte.macollectivite.fr/manage/users/)
-
-
-
-
+[https://connexion-moncompte.macollectivite.fr/manage/users/](https://connexion-moncompte.macollectivite.fr/manage/users/)
diff --git a/installation-7.md b/installation-7.md
index 32ae36c..f8f2a26 100644
--- a/installation-7.md
+++ b/installation-7.md
@@ -205,10 +205,5 @@ Exemple pour Combo :
 
     RequiresMountsFor=/srv/nfs
 
-Faire de même avec :
-
--   les services systemd-isés qui ont besoin de */srv/nfs* : Combo,
-    Fargo, Passerelle.
--   les services bientôt systemd-isés (avant fin 2017, donc prévoir dès
-    maintenant le supplément) : authentic2-multitenant, hobo,
-    hobo-agent, wcs
+Faire de même avec les services qui ont besoin de */srv/nfs* : Combo,
+    Fargo, Passerelle, authentic2-multitenant, hobo, hobo-agent, wcs.
-- 
2.20.1